      subroutine kinkk2(ikin,imom,ecm,m,p,x,ndim,dlips)
 
      use inprms
      use kincuts
      use ntnkin
 
      implicit none
 
      integer, parameter :: nepl=7
      integer :: ikin,imom,ndim
      real(dp) :: ecm,m(nepl),p(0:3,nepl),x(ndim),dlips,v(3),g
      real(dp), dimension(0:3) :: q1,q2,q3
      real(dp) :: sqsl1,sqsl2,sqsl3
      real(dp) :: sqsu1,sqsu2,sqsu3
      real(dp) :: sqs1,sqs2,sqs3
      real(dp) :: ds1,ds2,ds3
      real(dp) :: s1,s2,s3
      real(dp) :: dl1,dl2,dl3
 
      if (ikin <= nt32) then                                                    
       sqsl1=m(5)+m(6)                                                          
       sqsl2=m(3)+m(4)                                                          
       sqsl3=sqsl2+m(7)                                                         
       if (imom /= 1) then                                                      
        q1=p(:,5)+p(:,6)                                                        
        q2=p(:,3)+p(:,4)                                                        
        q3=q2+p(:,7)                                                            
       end if                                                                   
       if (ikin == 45) then                                                     
       sqsu1=ecm-sqsl3                                                          
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)                 
       sqsu3=ecm-sqs1                                                           
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)              
       sqsu2=sqs3-m(7)                                                          
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)                 
       end if                                                                   
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt33) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,7)
       end if
       if (ikin == 46) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt34) then
       sqsl1=m(7)+m(5)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,7)+p(:,5)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,6)
       end if
       if (ikin == 47) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 48) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 49) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(5),x(4:5),p(:,7),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt36) then
       sqsl1=m(5)+m(7)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,6)
       end if
       if (ikin == 50) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 51) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 52) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 53) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 54) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt38) then
       sqsl1=m(5)+m(7)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,6)
       end if
       if (ikin == 55) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt39) then
       sqsl1=m(6)+m(7)
       sqsl2=m(5)+sqsl1
       sqsl3=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,6)+p(:,7)
        q2=p(:,5)+q1
        q3=p(:,3)+p(:,4)
       end if
       if (ikin == 56) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 57) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 58) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(6),m(7),x(4:5),p(:,6),p(:,7),dl1)
       call kinff(imom,sqs2,m(5),sqs1,x(6:7),p(:,5),q1,dl2)
       call kinff(imom,sqs3,m(3),m(4),x(8:9),p(:,3),p(:,4),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt40) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(6)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,6)
        q3=q2+p(:,7)
       end if
       if (ikin == 59) then
       sqsu3=ecm-m(5)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 60) then
       sqsu3=ecm-m(5)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,m(5),sqs3,x(10:11),p(:,5),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt41) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(7)
       sqsl3=sqsl2+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,7)
        q3=q2+p(:,4)
       end if
       if (ikin == 61) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 62) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(7),x(6:7),p(:,3),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(4),x(8:9),q2,p(:,4),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt42) then
       sqsl1=m(5)+m(6)
       sqsl2=m(4)+m(7)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,4)+p(:,7)
        q3=p(:,3)+q2
       end if
       if (ikin == 63) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 64) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(4),m(7),x(6:7),p(:,4),p(:,7),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt43) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(7)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,7)
        q3=q2+p(:,6)
       end if
       if (ikin == 65) then
       sqsu3=ecm-m(5)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 66) then
       sqsu3=ecm-m(5)
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       if (ikin == 67) then
       sqsu3=ecm-m(5)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(7)
       ds1=(sqsu1-sqsl1)*(sqsu1+sqsl1)
       if (imom == 1) then
        s1=ds1*x(1)+sqsl1*sqsl1
       else
        s1=(q1(0)-q1(3))*(q1(0)+q1(3))-q1(1)*q1(1)-q1(2)*q1(2)
       end if
       sqs1=sqrt(s1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(7),x(6:7),q1,p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(5),sqs3,x(10:11),p(:,5),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt44) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 68) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 69) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       if (ikin == 70) then
       sqsu3=ecm-m(7)
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(5)
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(6:7),q1,p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt46) then
       sqsl1=m(3)+m(4)
       sqsl2=sqsl1+m(5)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,3)+p(:,4)
        q2=q1+p(:,5)
        q3=q2+p(:,6)
       end if
       if (ikin == 71) then
       sqsu3=ecm-m(7)
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       sqsu1=sqs2-m(5)
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       end if
       call kinff(imom,sqs1,m(3),m(4),x(4:5),p(:,3),p(:,4),dl1)
       call kinff(imom,sqs2,sqs1,m(5),x(6:7),q1,p(:,5),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,m(7),sqs3,x(10:11),p(:,7),q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt47) then
       sqsl1=m(5)+m(7)
       sqsl2=sqsl1+m(6)
       sqsl3=m(3)+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=q1+p(:,6)
        q3=p(:,3)+p(:,4)
       end if
       if (ikin == 72) then
       sqsu2=ecm-sqsl3
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 73) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       if (ikin == 74) then
       sqsu2=ecm-sqsl3
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       sqsu1=sqs2-m(6)
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs2
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,sqs1,m(6),x(6:7),q1,p(:,6),dl2)
       call kinff(imom,sqs3,m(3),m(4),x(8:9),p(:,3),p(:,4),dl3)
       call kinff(imom,ecm,sqs2,sqs3,x(10:11),q2,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt48) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,7)
       end if
       if (ikin == 75) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt52) then
       sqsl1=m(5)+m(6)
       sqsl2=m(3)+m(4)
       sqsl3=sqsl2+m(7)
       if (imom /= 1) then
        q1=p(:,5)+p(:,6)
        q2=p(:,3)+p(:,4)
        q3=q2+p(:,7)
       end if
       if (ikin == 76) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 77) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 78) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       if (ikin == 79) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi0,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi0,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(7)
       ds2=(sqsu2-sqsl2)*(sqsu2+sqsl2)
       if (imom == 1) then
        s2=ds2*x(2)+sqsl2*sqsl2
       else
        s2=(q2(0)-q2(3))*(q2(0)+q2(3))-q2(1)*q2(1)-q2(2)*q2(2)
       end if
       sqs2=sqrt(s2)
       end if
       call kinff(imom,sqs1,m(5),m(6),x(4:5),p(:,5),p(:,6),dl1)
       call kinff(imom,sqs2,m(3),m(4),x(6:7),p(:,3),p(:,4),dl2)
       call kinff(imom,sqs3,sqs2,m(7),x(8:9),q2,p(:,7),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,6))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,4))
        call boost(g,v,p(:,7))
       end if
      else if (ikin <= nt53) then
       sqsl1=m(7)+m(5)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(4)
       if (imom /= 1) then
        q1=p(:,7)+p(:,5)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,4)
       end if
       if (ikin == 80) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 81) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 82) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(7),m(5),x(4:5),p(:,7),p(:,5),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(4),x(8:9),q2,p(:,4),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,5))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt55) then
       sqsl1=m(5)+m(7)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,4)
       end if
       if (ikin == 83) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 84) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 85) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mpi,zero,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 86) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 87) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mpi,zero,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapbkk(imom,x(2),q2,mrho,gmrh,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(4),x(8:9),q2,p(:,4),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt56) then
       sqsl1=m(5)+m(7)
       sqsl2=m(3)+m(6)
       sqsl3=sqsl2+m(4)
       if (imom /= 1) then
        q1=p(:,5)+p(:,7)
        q2=p(:,3)+p(:,6)
        q3=q2+p(:,4)
       end if
       if (ikin == 88) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(4)
       call mapakk(imom,x(2),q2,sqscut,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(7),x(4:5),p(:,5),p(:,7),dl1)
       call kinff(imom,sqs2,m(3),m(6),x(6:7),p(:,3),p(:,6),dl2)
       call kinff(imom,sqs3,sqs2,m(4),x(8:9),q2,p(:,4),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,7))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,4))
       end if
      else if (ikin <= nt58) then
       sqsl1=m(5)+m(4)
       sqsl2=m(3)+m(7)
       sqsl3=sqsl2+m(6)
       if (imom /= 1) then
        q1=p(:,5)+p(:,4)
        q2=p(:,3)+p(:,7)
        q3=q2+p(:,6)
       end if
       if (ikin == 89) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 90) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 91) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 92) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(6)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(4),x(4:5),p(:,5),p(:,4),dl1)
       call kinff(imom,sqs2,m(3),m(7),x(6:7),p(:,3),p(:,7),dl2)
       call kinff(imom,sqs3,sqs2,m(6),x(8:9),q2,p(:,6),dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,7))
        call boost(g,v,p(:,6))
       end if
      else if (ikin <= nt59) then
       sqsl1=m(5)+m(4)
       sqsl2=m(6)+m(7)
       sqsl3=m(3)+sqsl2
       if (imom /= 1) then
        q1=p(:,5)+p(:,4)
        q2=p(:,6)+p(:,7)
        q3=p(:,3)+q2
       end if
       if (ikin == 93) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 94) then
       sqsu1=ecm-sqsl3
       call mapakk(imom,x(1),q1,sqscut,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 95) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapakk(imom,x(3),q3,sqscut,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       if (ikin == 96) then
       sqsu1=ecm-sqsl3
       call mapbkk(imom,x(1),q1,mrho,gmrh,sqsl1,sqsu1,s1,sqs1,ds1)
       sqsu3=ecm-sqs1
       call mapbkk(imom,x(3),q3,mrho,gmrh,sqsl3,sqsu3,s3,sqs3,ds3)
       sqsu2=sqs3-m(3)
       call mapbkk(imom,x(2),q2,mpi,zero,sqsl2,sqsu2,s2,sqs2,ds2)
       end if
       call kinff(imom,sqs1,m(5),m(4),x(4:5),p(:,5),p(:,4),dl1)
       call kinff(imom,sqs2,m(6),m(7),x(6:7),p(:,6),p(:,7),dl2)
       call kinff(imom,sqs3,m(3),sqs2,x(8:9),p(:,3),q2,dl3)
       call kinff(imom,ecm,sqs1,sqs3,x(10:11),q1,q3,dlips)
       dlips=dlips*ds1*ds2*ds3
     &            *dl1*dl2*dl3
       if (dlips <= 0.d0) then
        dlips=0.d0
        return
       end if
       if (imom == 1 .and. dlips > 0.d0) then
        v=q1(1:)/q1(0)
        g=q1(0)/sqs1
        call boost(g,v,p(:,5))
        call boost(g,v,p(:,4))
        v=q2(1:)/q2(0)
        g=q2(0)/sqs2
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
        v=q3(1:)/q3(0)
        g=q3(0)/sqs3
        call boost(g,v,p(:,3))
        call boost(g,v,p(:,6))
        call boost(g,v,p(:,7))
       end if
      end if
 
      end
